#!/usr/bin/env python
import ujson as json
import sys
'''
U|A|1431511200|ris|rrc01|56730|2001:7f8:4::dd9a:1|2a00:bdc0:e004::/48|2001:7f8:4::dd9a:1|56730 51945 6939 47541 28709|28709|51945:8330 51945:65104 51945:65402 51945:65503||
U|A|1431511200|ris|rrc01|286|195.66.224.54|103.56.70.0/24|195.66.224.54|286 6762 7713 133825|133825|286:18 286:19 286:28 286:29 286:49 286:800 286:888 286:3031 286:4517 286:4990 6762:1 6762:92 6762:16500 6762:20002 6762:20006 6762:20007 6762:20009 6762:20018 6762:20022 6762:20025||
U|A|1431511200|ris|rrc01|286|195.66.224.54|194.53.0.0/24|195.66.224.54|286 12859 1132|1132|286:286 286:3031 286:4516 286:4990 12859:4000 12859:4993||
U|A|1431511200|ris|rrc01|286|195.66.224.54|145.12
'''

comm2city = {}

with open(sys.argv[1]) as inf:
   for line in inf:
      if line.startswith('#'):
         continue
      try:
         comm,city = line.split(' ',1) 
         comm2city[ comm ] = city
      except:
         print line
         raise

cache = {}

exc = 0

for line in sys.stdin:
   try:
      fields = line.split('|')
      ts = fields[2]
      peerip = fields[4]
      peeras = fields[5]
      pfx = fields[7]
      key = ( peerip, peeras, pfx )
      path = fields[9]
      comm_list = fields[11]
      cities = []
      for comm in comm_list.split(' '):
         if comm in comm2city:
            cities.append( comm2city[comm] )
            #print "%s\t%s\t%s\t%s\t%s" % (peerip,peeras,pfx,path,comm2city[comm])
      if key in cache:
            #print "%s in cache" % ( key, )
            if cmp( cities, cache[key]['cities'] ) != 0:
               struct = {'timestamp': ts, 'key': key, 'cities-old': cache[key]['cities'], 'cities-new': cities, 'path-old': cache[key]['path'], 'path-new': path }
               print json.dumps( struct )
      cache[key] = {
         'path': path,
         'cities': cities,
      }
      
   except:
      #print line
      #raise
      exc += 1

print >>sys.stderr, "nr. exceptions: %d" % exc
