#!/usr/bin/env python
import sys
import ujson as json
import re

'''
{u'path-old': u'29611 174 8100', u'cities-old': [u'North-America\r\n', u'United-States\r\n'], u'timestamp': u'1431511950', u'path-new': u'29611 19151 8100', u'cities-new': [u'WesternUS\r\n', u'Los-Angeles,US\r\n'], u'key': [u'rrc01', u'29611', u'107.167.48.0/21']}
'''
city=sys.argv[1]
BIN=60

city_re = re.compile(city, re.IGNORECASE)

output={}

for line in sys.stdin:
   d = json.loads( line )
   match_old = None
   match_new = None
   ts_bin = int(d['timestamp'])
   ts_bin -= ts_bin % BIN
   output.setdefault( ts_bin, {'up':0, 'down': 0} )
   if d['path-new'] == '':
      # withdraw
      continue
   for city_old in d['cities-old']:
      match_old = city_re.search( city_old )
      if match_old:
         break
   for city_new in d['cities-new']:
      match_new = city_re.search( city_new )
      if match_new:
         break
   if match_old and match_new:
      continue
   elif match_old:
      output[ ts_bin ]['up'] += 1
      #print "OLD: %s " % (d)
   elif match_new:
      output[ ts_bin ]['down'] += 1
      #print "NEW: %s " % (d)

for ts in sorted( output.keys() ):
   print "%s %s %s" % (ts, output[ts]['up'], output[ts]['down'])
